<?php
#################################################
//	RiddleMeThis PHP Runtime
//	
//	(c) 2003-2004 One Two Red Blue
//	Written by Tonio Loewald
//	tonio@onetworedblue.com 
//	
//	This program is licensed to anyone under the
//	GNU Lesser General Public License
//	http://www.opensource.org/licenses/lgpl-license.php
//
//	Version 1.0.5 September 26, 2004
//	* Implemented Check All That Apply questions
//
//	Version 1.0.4 April 20, 2004
//  * Corrected bug in session id generation (months vs minutes)
//
//	Version 1.0.3 October 30, 2003
//	* Corrected bug that was causing warnings and misbehavior
//	  with some PHP installations.
//
//	Version 1.0.2 September 25, 2003
//	* Corrected bug relating to column names containing SPACES.
//
//	Version 1.0.1 September 24, 2003
//	* Corrected bug in headings which did not remove "answer all
//	  questions" text when it's not necessary.
//	* The prompt (that the user answer all questions, or whatever
//	  you choose to change it to) now only appears if there is at 
//	  least one unanswered question on the page.
//	* Modified redirection to use Javascript first, META refresh 
//	  second, and finally allow the user to manually click the
//	  link.
//	  Javascript added because IE does not properly implement 
//	  META refresh.
//
//	Version 1.0 September 16 2003
//	* Changed licensing to LGPL
//
//	Version 1.0B11 September 16 2003
//	* Fixed bug in conditional sections (they should work now!)
//	  Many many thanks to Carlos Navarette for his help figuring
//	  this bug out.
//	* Debug settings are now selected from RiddleMeThis.
//	* Other settings can also be modified from RiddleMeThis.
//
//	Version 1.0B10
//	* Fix: No longer assumes the file will be named "form.rmt"
//	  rather than "Form.rmt" for case-sensitive servers
//	* Fix: no longer assumes form.rmt will be smaller than 32kB
//	  (yes, ouch!)
//	
//	Version 1.0B9 June 28 2003
//
//	* Implemented random variable assignment
//	* Implemented conditional sections
//	* Switched calls to rand() to mt_rand()
//	  based on recommendations in PHP online docs.
//	* Fixed display of quotation marks in questions.
//
//	Version 1.0B8 May 6 2003
//	* More stuff put into constants for easier
//	  end-user modification.
//	* Heading message now changes when form is
//	  complete.
//
//	Version 1.0B7
//	* Decode question text for all items not just
//    plain text items. [Fix]
//	* Corrected case error in DATA_PATH (make sure
//	  your data directory is named "Data" or modify
//	  the DATA_PATH constant below).
//	Change as of 1.0:
//	  Note that DATA_PATH is now set inside RiddleMeThis.
//
//	Version 1.0B6
//	* Most questionnaire preferences implemented!
//	- ForwardEnabledOnCompletion
//  - BackButtonEnabled
//  - ShowSection
//  - ShowProgress
//	* Better feedback for unanswered questions
//	* Changed promotional links to target _blank
//	* Replaced hard-wired paths with global constants
//	* No longer spam PHP comments in web page!
//	* Minor efforts toward PHP beautification :)
//	
//	Version 1.0B5 March 27 2003
//	* Enforce filling in of forms
//	* Use constants to control debug feedback
#################################################
?>
<!-- This page was generated by RiddleMeThis Runtime -->
<!-- http://www.onetworedblue.com/RiddleMeThis/      -->
<?php
#################################################
##               PHP Utilities
#################################################
	function SetFormConstant($settings, $itsname, $defaultvalue) {
		$setting = $settings[$itsname];
		if( is_string($setting) ) {
			switch( $setting ) {
				case '':
					define($itsname, $defaultvalue);
				case 'false':
					define($itsname, false);
				case 'true':
					define($itsname, true);
				default:
					define($itsname, $setting);
			}
		} else {
			define($itsname, $defaultvalue);
		}
	}
	
	function LoadSettings($form) {
		$settings = stringToArray($form['prefs']['OnlineSettings'], chr(4), chr(5));
		
		// DEBUG CONSTANTS
		SetFormConstant($settings, 'DEBUG', false);
		// To show $results and $_POST
		SetFormConstant($settings, 'DEBUG_RESULTS', false);
		// To show form preferences
		SetFormConstant($settings, 'DEBUG_FORMPREFS', false);
		// To show server data
		SetFormConstant($settings, 'DEBUG_SERVER', false);
		// To show the answer verification details
		SetFormConstant($settings, 'DEBUG_VERIFY', false);
		// To see a breakdown of the form as it loads
		SetFormConstant($settings, 'DEBUG_ITEMS', false);
		// To show random variable settings
		SetFormConstant($settings, 'DEBUG_RANDOMVARIABLES', false);
		// To show conditional sections at work
		SetFormConstant($settings, 'DEBUG_CONDITIONALSECTIONS', false);
		
		// PATH CONSTANTS
		SetFormConstant($settings, 'DATA_PATH', 'Data/');
		SetFormConstant($settings, 'VIDEO_PATH', 'Videos/');
		SetFormConstant($settings, 'IMAGE_PATH', 'Images/');
		
		// OTHER CONSTANTS
		// Heading message when user completes form
		SetFormConstant($settings, 'HEADING_DONE', 'Form Completed');
		// Heading message shown when user must answer all questions
		SetFormConstant($settings, 'HEADING_ANSWERALL', 'Please answer all questions before proceeding...');
		// Heading message shown when user must answer all questions and tries to proceed with some not answered
		SetFormConstant($settings, 'HEADING_ANSWERHILITED', 'Please answer <font color="#FF0000">hilighted</font> questions before proceeding...');
		// Message displayed when user completes form
		SetFormConstant($settings, 'MESSAGE_THANKS', 'Thank you for completing this form.');
		// Window title
		SetFormConstant($settings, 'FORM_NAME', 'RiddleMeThis Runtime');
		// Footer
		SetFormConstant($settings, 'FORM_FOOTER', 'This form was created by <a href="http://www.onetworedblue.com/RiddleMeThis/" target="_blank">RiddleMeThis</a> Runtime, &copy;2003 <a href="http://www.onetworedblue.com/" target="_blank">One Two Red Blue</a>.</font>');
		// Text caption of continue button
		SetFormConstant($settings, 'BUTTON_CONTINUE_NAME', 'Continue');
		// Text caption of back button
		SetFormConstant($settings, 'BUTTON_BACK_NAME', 'Back');
		// Redirect on completion
		SetFormConstant($settings, 'REDIRECT_ON_COMPLETION', false);
		SetFormConstant($settings, 'REDIRECT_ON_COMPLETION_URL', 'thankyou.html');
		SetFormConstant($settings, 'REDIRECT_ON_COMPLETION_MESSAGE', 'Please click here if your browser does not proceed within a few seconds.');
	}

	################################
	## delivers raw POST parameters
	################################
	function rawp($name) {
		return ini_get('magic_quotes_gpc')
			? stripslashes($_POST[$name])
			: $_POST[$name];
	}
		
	####################################################
	## Simple text file i/o routines
	## NB: permissions need to be set or they will fail
	####################################################
	
	function savetext($filename, $filetext) {
		$file = fopen($filename, 'w');
		if ( $file ) {
			$err = fwrite($file, $filetext);
			$err = fclose($file);
		}
	}
	
	function loadtext($filename) {
		if( file_exists( $filename )) {
			$file = fopen($filename, 'r');
			if ( $file ) {
				$filetext = fread($file, 1000000);
				$err = fclose($file);
				$filetext = $filetext;
				return $filetext;
			} else {
				return '';
			}
		} else { 
			return '';
		}
	}
	
	#######################################
	## Displays an array as a simple table
	#######################################
	function echoarray($theArray) {
		if ( count($theArray) ) {	
			echoR( '<table padding=2 border=1><tr>' );
			echoP( 'Property', 'th' );
			echoP( 'Value', 'th' );
			echoR( '</tr>' );
			foreach ($theArray as $prop => $value) {
				echo "<tr>";
				echoP( $prop, "td" );
				if (is_array($value)) {
					echo('<td>');
					echoArray( $value );
					echo('</td>');
				} else {
					echoP( $value, "td" );
				}
				echo "</tr>";
			}
			echo "</table>\r";
		}
	}
	
	function conditionalString($condition, $string1, $string2='') {
		if($condition)
			return $string1;
		else
			return $string2;
	}
	
	################################################
	## Displays a table of POST variables submitted
	################################################
	function listvars() {
		if( $_SERVER['REQUEST_METHOD'] == 'POST' ) {
			echoarray( $_POST );
		}
	}
	
	####################################################
	## Append newly submitted responses to session file
	####################################################
	function UpdateSession($SessionID) {
		global $results;
		// Create associative array from session file
		$SessionFilePath = DATA_PATH . $SessionID . '.txt';
		$existing = loadtext($SessionFilePath);
		$lines = split(chr(13), $existing, 3);
		if ( count($lines) == 3 ) {
			$ip = $lines[2];
			if( $ip == $_SERVER['REMOTE_ADDR']) {
				$columns = split(chr(9), $lines[0]);
				$values = split(chr(9), $lines[1]);
				
				// echoP('Columns', 'h2');
				// echoarray($columns);
				
				// echoP('Values', 'h2');
				// echoarray($values);
				
				for( $i = 0; $i < count($columns); $i++) {
					if ($columns[$i] != '') {
						$results[$columns[$i]] = $values[$i];
					}
				}
			}
		}
		
		// Add/Modify array based on new data
		foreach ($_POST as $prop => $value) {
			if( substr($prop, 0, 4) == "COL_" ) {
				$results[substr($prop, 4)] = EncodeAnswer($value);
			}
		}
		// echoP( 'Results', 'h2' );
		// echoarray( $results );
		
	}
	
	function SaveSession($SessionID) {
		global $results;
		
		// echoP( 'Saving session...', 'h3' );
		// echoarray( $results );
		
		$columns = '';
		$values = '';
		foreach($results as $prop => $value) {
			$columns = $columns . $prop . chr(9);
			$values = $values . $value . chr(9);
		}
		if ( Done() ) {
			$SessionFilePath = DATA_PATH . $SessionID . '_completed.txt';
		} else {
			$SessionFilePath = DATA_PATH . $SessionID . '.txt';
		}
		savetext($SessionFilePath, $columns . chr(13) . $values . chr(13) . $_SERVER['REMOTE_ADDR']);
		// Save to second location?
		// Consider deleting temp file.
	}
	
	#####################################################
	## Decode / Encode Slashes (RMT compatibility)
	#####################################################
	function DecodeQuestion($s) {
		$t = str_replace('\\n', '<br>', $s);
		$t = str_replace('\\q', '&quot;', $t);
		return $t;
	}
	
	function DecodeAnswer($s) {
		$t = str_replace('\\n', chr(13), $s);
		return $t;
	}
	
	function EncodeAnswer($s) {
		$t = str_replace(chr(13), '\\n', $s);
		return $t;
	}
	
	#####################################################
	## echos a string surrounded by standard paired tags
	#####################################################
	function echoP($msg, $tag="P") {
		echo "<" . $tag . ">\r";
		echo "\t" . $msg . "\r";
		echo "</" . $tag . ">\r";
	}
	
	function echoR($msg) {
		echo $msg . "\r";
	}
	
	##########################################
	## Break string into an associative array
	##########################################
	function stringToArray($s, $propDelim='=', $itemDelim='\r') {
		$items = split($itemDelim, $s);
		$a = array();
		for($i = 0; $i < count($items); $i++) {
			// Added limit to allow for the conditions array (which has three columns)
			$splitItem = split($propDelim, $items[$i], 2);
			if((count($splitItem) > 1) && ($splitItem[0] != '')) {
				$a[$splitItem[0]] = $splitItem[1];
			}
		}
		return $a;
	}
	
	########################################################################
	## Load Form Specification
	## This function loads a RiddleMeThis form document into two
	## associative arrays...
	## $formPrefs contains the global form settings
	## $sections contains the sections (each section contains its own items
	########################################################################
	function loadForm() {
		// 1.0B10 fix for case-sensitive servers
		if(file_exists('form.rmt')) {
			$formSpec = split(chr(13), loadtext( 'form.rmt' ));
		}
		elseif(file_exists('Form.rmt')) {
			$formSpec = split(chr(13), loadtext( 'Form.rmt' ));
		}
		else {
			die('Could not find form specification file "form.rmt".');
		}
		$sections = array();
		$formPrefs = array();
	
		for($i = 0; $i < count($formSpec); $i++) {
			// Changed to prevent use of '=' in conditions from breaking
			// this line of code:
			$theItem = split('=', $formSpec[$i], 2);
			$itemType = $theItem[0];
			$itemSpec = stringToArray($theItem[1], chr(7), chr(10));
			switch($itemType) {
			case 'FORM':
				$formPrefs = $itemSpec;
				break;
			case 'SECTION':
				$itemSpec['items'] = array();
				$sections[] = $itemSpec;
				break;
			case 'ITEM':
				if(count($sections)) {
					$sections[count($sections)-1]['items'][] = $itemSpec;
				} else {
					die('Fatal error in form.rmt. ITEM encountered before first SECTION.');
				}
				break;
			}
		}
		
		return array('prefs' => $formPrefs, 'sections' => $sections);
	}
	##################
	## Form Complete?
	##################
	function done( $offset=0) {
		global $CurrentPageNumber;
		if ($CurrentPageNumber + $offset > sectioncount())
			return true;
		else
			return false;
	}
	
	function sectioncount() {
		global $form;
		return count($form['sections']);
	}
	
	#################
	## VerifyAnswers
	#################
	function VerifyAnswers($page) {
		global $form;
		global $results;
		global $UnansweredQuestions;
		
		if($page < 1) {
			$verified = 1;
		} else {
			if( $form['prefs']['ForwardEnabledOnCompletion'] != 'TRUE' ){
				return 1;
			}
			$verified = 1;
			$section = $form['sections'][$page - 1];
			$items = $section['items'];
			foreach($items as $item) {
				$col = str_replace(' ', '_', $item['ColumnName']);
				// Modified in 1.0.5 to handle Pick All That Apply Questions
				if( ($item['RecordResponse']=='TRUE') && ($item['ItemType']!='Pick All That Apply Question') ) {
					if ( $item['AllowNullResponse']=='TRUE' ) {
						if( DEBUG_VERIFY ) {
							echoP($col . ' ALLOWS NULL RESPONSE');
						}	
					} elseif( $results[$col]==NULL ) {
						if( DEBUG_VERIFY ) {
							echoP($col . ' IS NULL');
						}
						$UnansweredQuestions[$col] = true;
						$verified = 0;
					} else {
						if( DEBUG_VERIFY ) {
							echoP($col . ' == ' . $results[$item['ColumnName']]);
						}
					}
				}
			}
		}
		return $verified;
	}
	
	function PromptUser($page) {
		global $form;
		global $results;
		
		if($page < 1) {
			return 0;
		} else {
			if( $form['prefs']['ForwardEnabledOnCompletion'] != 'TRUE' ){
				return 0;
			}
			$section = $form['sections'][$page - 1];
			$items = $section['items'];
			foreach($items as $item) {
				$col = str_replace(' ', '_', $item['ColumnName']);
				if( $item['RecordResponse']=='TRUE' ) {
					if ( $results[$col]==NULL && !$item['AllowNullResponse']=='TRUE' ) {
						return 1;
					}
				}
			}
			return 0;
		}
	}
	
	################
	## OptionsArray
	################
	// Rows are delimited by chr(5)
	// Columns are delimited by chr(4)
	function OptionsArray($s) {
		$rows = split(chr(5), $s);
		for($i = 0; $i < count($rows); $i++){
			$rows[$i] = split(chr(4), $rows[$i]);
		}
		return $rows;
	}
	
	######################
	## RANDOM VARIABLES ##
	######################
	
	######################
	## SetRandomVariables
	######################
	
	function SetRandomVariables( $form ) {
		global $results;
		
		// $randomVariableSpecs = stringToArray($form['prefs']['RandomVariables'], chr(4), chr(5));
		$randomVariableSpecs = stringToArray($form['prefs']['RandomVariables'], chr(4), chr(5));
		
		if( DEBUG_RANDOMVARIABLES ) {
			echoP( 'Random Variable Specifications' , 'h3' );
			echoarray( $randomVariableSpecs );
		}
		
		foreach($randomVariableSpecs as $varname => $spec) {
			$spec = stringToArray($spec, ',', ';');
			$totalWeight = 0;
			foreach($spec as $weight) {
				$totalWeight += $weight;
			}
			// Multiply by 1000 to handle fractional weights
			$whichValue = mt_rand(1, $totalWeight * 1000);
			foreach($spec as $value => $weight) {
				$whichValue -= $weight * 1000;
				if( $whichValue <= 0 ) {
					$results[$varname] = $value;
					break;
				}
			}
		}
		
		if( DEBUG_RANDOMVARIABLES ) {
			echoP( 'Random Variable Settings' , 'h3' );
			echoarray( $results );
		}
		
	}
	
	##########################
	## CONDITIONAL SECTIONS ##
	##########################
	
	##################
	## IncludeSection
	##################
	function IncludeSection( $section ) {
		global $results;
		
		$conditions = stringToArray( $section['Conditions'], chr(4), chr(5) );
		
		if( DEBUG_CONDITIONALSECTIONS ) {
			echoP( 'Section Conditions', 'h3' );
			echoP( $section['IncludeOrSkip'] . ' this section unless ' . $section['OneOrAll'] . ' of the conditions are met:' );
			echoarray( $conditions );
		}
		
		if( $section['IncludeOrSkip'] == 'Include' )
			$Include = true;
		else
			$Include = false;
		
		// If there are no conditions then we're done!
		if( count( $conditions ) == 0 ) {
			return $Include;
		}
			
		$OneConditionMet = false;
		$OneConditionFailed = false;
		
		foreach( $conditions as $varname => $condition ) {
			$condition = split( chr(4), $condition );
			$varValue = strtolower( $results[$varname] );
			$compareValue = strtolower( $condition[1] );
			switch($condition[0]) {
			case '=':
				if( $varValue == $compareValue )
					$OneConditionMet = true;
				else
					$OneConditionFailed = true;
				break;
			case '!=':
				if( $varValue != $compareValue )
					$OneConditionMet = true;
				else
					$OneConditionFailed = true;
				break;
			case '<':
				if( $varValue < $compareValue )
					$OneConditionMet = true;
				else
					$OneConditionFailed = true;
				break;
			case '>':
				if( $varValue > $compareValue )
					$OneConditionMet = true;
				else
					$OneConditionFailed = true;
				break;
			case '<=':
				if( $varValue <= $compareValue )
					$OneConditionMet = true;
				else
					$OneConditionFailed = true;
				break;
			case '>=':
				if( $varValue >= $compareValue )
					$OneConditionMet = true;
				else
					$OneConditionFailed = true;
				break;
			}
		}
		
		if( $section['OneOrAll'] == 'One' ) {
			if ( $OneConditionMet )
				$Include = !( $Include );
		}
		else {
			if ( !( $OneConditionFailed ) )
				$Include = !( $Include );
		}
		if( DEBUG_CONDITIONALSECTIONS ) {
			if( $Include )
				echoP( 'Section included');
			else
				echoP( 'Section skipped');
		}
		
		return $Include;
	}
	
	function NextPage($form, $page) {
		$pagecount = sectioncount();
		for( $p = $page + 1; $p <= $pagecount; $p++ ) {
			if( IncludeSection( $form['sections'][$p - 1] ) )
				return $p;
		}
		return $pagecount + 1;
	}
	
	function PreviousPage($form, $page) {
		for( $p = $page - 1; $p >= 1 ; $p-- ) {
			if( IncludeSection( $form['sections'][$p - 1] ) )
				return $p;
		}
		return 1;
	}
	
	################
	## BuildSection
	################
	function BuildSection($form, $page, $HiliteUnanswered) {
		global $results;
		global $UnansweredQuestions;
		
		if( done() ){
			// Should allow for a final URL to jump to at end of web form
			echoR('<p align="center">' . MESSAGE_THANKS . '</p>');
			
			if( REDIRECT_ON_COMPLETION ) {
				echoR( '<script language="javascript">' );
				echoR( 'location.replace("' . REDIRECT_ON_COMPLETION_URL . '")' );
				echoR( '</script>' );
				echoR( '<meta http-equiv="refresh" content="2;' . REDIRECT_ON_COMPLETION_URL . '">' );
				echoR( '<p align="center"><a href="' . REDIRECT_ON_COMPLETION_URL . '">' . REDIRECT_ON_COMPLETION_MESSAGE . '</a></p>' );
			}
		} else {
			$section = $form['sections'][$page - 1];
		
			echoR( '<table width="100%" border="0" cellspacing="0" cellpadding="4">' );
			$items = $section['items'];
			
			foreach($items as $item) {
				$type = $item['ItemType'];
				$col = str_replace(' ', '_', $item['ColumnName']);
				if( $UnansweredQuestions[$col] ) {	
					echoR( '<tr><td bgcolor="#FFCCCC">' );
				} else {
					echoR( '<tr><td>' );
				}
				switch($type){
				// Text-Response Question
				case 'Text-Response Question':
					echoP( DecodeQuestion($item['QuestionText']) );
					echoR( '<blockquote>' );
					if ($item['Multiline'] == 'TRUE') {
						echoR ('<textarea name="COL_' . $col . '" cols="60">' . DecodeAnswer($results[$col]) . '</textarea>' );
					} else {
						echoR ('<input name="COL_' . $col . '" type="text" value="'. $results[$col] .'" size=60>' );
					}
					echoR( '</blockquote>' );
					break;
				// Multiple-Choice Question
				case 'Multiple-Choice Question':
					echoP( DecodeQuestion($item['QuestionText']) );
					$options = OptionsArray($item['Options']);
					echoR( '<blockquote><p>' );
					foreach($options as $option) {
						echo '<input name="COL_' . $col . '" type="radio" value="' . $option[1] .'" ';
						echo conditionalString($option[1] == $results[$col], 'checked') .'>';
						echo DecodeQuestion( $option[0] );
						echoR( '<br>' );
					}
					echoR( '</p></blockquote>' );
					break;
				// Pick All That Apply Question
				case 'Pick All That Apply Question';
					echoP( DecodeQuestion($item['QuestionText']) );
					$options = OptionsArray($item['Options']);
					foreach($options as $option) {
						$qcol = $col . '_' .  $option[0];
						echo '<input type="checkbox" name="' . $qcol . '" value="checkbox" ';
						echo conditionalString($option[1] == $results[$col], 'checked') .'>';
						echo DecodeQuestion( $option[0] );
						echoR( '<br>' );
					}
				// Text Item
				case 'Text':
					echoP( DecodeQuestion($item['Text']) );
					break;
				// Range-Response Question
				case 'Range-Response Question':
					echoP( DecodeQuestion($item['QuestionText']) );
					echo '<p align="center">';
					echo $item['LabelMin'] . '&nbsp;';
					for( $i = $item['ValueMin']; $i <= $item['ValueMax']; $i ++ ){
						echo '<input name="COL_' . $col . '" type="radio" value="' . $i .'" ';
						echo conditionalString($i == $results[$col], 'checked') .'>';
					}
					echo '&nbsp;' . $item['LabelMax'];
					echoR( '</p>' );
					break;
				// Pick Image Question
				case 'Pick Image Question':
					echoP( DecodeQuestion($item['QuestionText']) );
					$options = OptionsArray($item['Options']);
					echoR( '<blockquote><p>' );
					echoR( '<table width="100%" border="0" cellspacing="0" cellpadding="4"><tr>' );
					foreach($options as $option) {
						echo '<p align="center"><td><img src="' . IMAGE_PATH . $option[0] . '">';
						echo '<br>';
						echo '<input name="COL_' . $col . '" type="radio" value="' . $option[1] .'" ';
						echo conditionalString($option[1] == $results[$col], 'checked') .'>';
						echoR( DecodeQuestion( $option[2] ).'</td></p>' );
					}
					echoR( '<tr></table>' );
					echoR( '</p></blockquote>' );
					break;
				// Picture
				case 'Picture':
					echoP( '<img src="' . IMAGE_PATH . $item['picture'] . '">' );
					break;
				// Video
				case 'Video':
					echo '<p><embed src="' . VIDEO_PATH . $item['video'] . '"';
					echo ' AUTOPLAY="' . $item['PlayAuto'] . '"';
					echo ' LOOP="' . $item['Loop'] . '"';
					echo ' CONTROLLER="' . $item['ShowControls'] . '"';
					echoR( ' pluginspage="http://quicktime.apple.com/"></embed></p>' );
					break;
				default:
					echoP('Error in form. Unknown item type: ' . $type, 'h3');
				}
				if( DEBUG_ITEMS ) {
					echoArray( $item );
				}
				echoR( '</td></tr>' );
			}
			echoR( '</table>' );	
		}
	}
	
	// umask(077);
	$form = loadForm();
	
	// Initialise results (prevent warning!) 10/30/03
	$results = array();
	loadSettings($form);
	if( DEBUG_FORMPREFS ) {
		echoP( 'Form Preferences' , 'h3' );
		echoarray( $form['prefs'] );
	}

	if($_SERVER['REQUEST_METHOD'] == 'GET') {
		// If no session exists, create one
		$SessionID = date('Y_m_d_H_i_s_') . mt_rand(100000,999999);
		SetRandomVariables( $form );
		// $CurrentPageNumber = 1;
		$CurrentPageNumber = NextPage( $form, 0 );
	} elseif ($_SERVER['REQUEST_METHOD'] == 'POST') {
		// Recover session state
		$SessionID = rawp('SessionFile');
	// Load existing session data
		$CurrentPageNumber = rawp("CurrentPageNumber");
		$SubmitButton = rawp('SubmitButton');
		UpdateSession($SessionID);
		if($SubmitButton == 'Continue') {
			// If the relevant questions were answered
			$UnansweredQuestions = array();
			if( VerifyAnswers($CurrentPageNumber) ) {
				// $CurrentPageNumber += 1;
				$CurrentPageNumber = NextPage( $form, $CurrentPageNumber );
				$HiliteUnanswered = 0;
			} else {
			// otherwise hilite unanswered questions
				$HiliteUnanswered = 1;
			}
		} elseif ($SubmitButton == ' Back ') {
			// $CurrentPageNumber -= 1;
			$PreviousPage = NextPage( $form, $CurrentPageNumber );
		}
	} else {
		die('This page only supports GET and POST requests.');
	}
	SaveSession($SessionID);
			
	if( ($form['prefs']['ShowSection'] == 'TRUE') && $CurrentPageNumber && !Done() ) {
		$form_title = FORM_NAME . ' | ' . $form['sections'][$CurrentPageNumber - 1]['SectionName'];
	} else {
		$form_title = FORM_NAME;
	}
?>

<html>
<head>
<title>
<? echo $form_title ?>
</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body bgcolor="#FFFFFF" text="#000000" link="#3300FF" vlink="#990099" alink="#FF0000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<!-- BEGIN THE FORM -->
<form method="POST" action="<?php echo $_SERVER['../PHP_SELF'] ?>">
  <table width="100%" border="0" cellpadding="6" cellspacing="0">
    <tr>
      <td align="center" valign="bottom" bgcolor="#CCCCCC">&nbsp;</td>
      <th height="36" valign="bottom" bgcolor="#CCCCCC">
<?php
	$prefs = $form['prefs'];
	if( $HiliteUnanswered ) {
		echo HEADING_ANSWERHILITED;
	} else {
		if( done() ) {
			echo HEADING_DONE;
		} elseif( PromptUser($CurrentPageNumber) ) {
			echo HEADING_ANSWERALL;
		} else {
			echo '&nbsp;';
		}
	}
?>
	</th>
		<input name="SessionFile" type="hidden" value=<? echo $SessionID; ?>>
		<input name="CurrentPageNumber" type="hidden" value=<? echo $CurrentPageNumber; ?>>
      <td align="center" valign="bottom" bgcolor="#CCCCCC">&nbsp;</td>
    </tr>
    <tr> 
      <td align="center" valign="bottom" bgcolor="#CCCCCC">&nbsp;</td>
      <td>
<?php
	BuildSection($form, $CurrentPageNumber, $HiliteUnanswered);
?>
		</td>
      <td align="center" valign="bottom" bgcolor="#CCCCCC">&nbsp;</td>
    </tr>
    <tr> 
      <td width="80" align="center" valign="bottom" bgcolor="#CCCCCC"> <div align="center">
<?php
	// Back Button
	if( $prefs['BackButtonEnabled'] == 'TRUE' ) {
		if( ($CurrentPageNumber > 1) && (! done())) {
			echo '<input name="SubmitButton" type="submit" value=" ' . BUTTON_BACK_NAME . ' ">';
		} else {
			echo '&nbsp;';
		}
	}
?>
	</div></td>
      <td bgcolor="#CCCCCC"> <div align="center"> 
<?php 
	// Show Progress
	if( ($prefs['ShowProgress'] == 'TRUE') && ($CurrentPageNumber) && (!done()) ){
		echoR('Page ' . $CurrentPageNumber . '/' . sectioncount());
	} else {
		echoR('&nbsp;');
	}
?>	
      </div><td width="80" align="center" valign="bottom" bgcolor="#CCCCCC"> <div align="center"> 
<?php
	// Continue Button
	if( ! done() ) {
		echo '<input name="SubmitButton" type="submit" value="' . BUTTON_CONTINUE_NAME . '">';
	} else {
		echo '&nbsp;';
	}
?>
        </div></td>
    </tr>
  </table>
</form>

<?php
	// General Debugging Information
	if( DEBUG_VERIFY ) {
		echoP( 'UnansweredQuestions', 'h3' );
		echoarray( $UnansweredQuestions );
	}
	
	if( DEBUG_RESULTS ) {
		echoP( 'Results', 'h3' );
		echoarray( $results );
		echoP( 'Post Variables', 'h3' );
		listvars();
	}
	
	if( DEBUG_SERVER ) {
		echoP( 'Server', 'h3' );
		echoarray( $_SERVER );
	}
?>

	<p align="center"><font size="-1">
		<?php echo( FORM_FOOTER ); ?></div></td>
	</p>
</body>
</html>
